<template>
  <div>
<!-- select 2 demo -->
    <b-modal
      id="modal-editAttendance"
      title="Editar registro de asistencia"
      hide-footer
    >
      <b-form>
     
        <b-form-group
          label="Fecha"
          label-for="start_date"
        >
            <b-form-datepicker  :disabled="true" id="start_date" v-model="formData.date" class="mb-2"></b-form-datepicker>
        </b-form-group>

        <b-form-group
              label="Seleccione la hora de inicio de inicio de la jornada laboral del usuario:"
              label-for="timepicker-check-in"
              class="w-50"
            >
  
            <b-form-timepicker
              id="timepicker-check-in"
              placeholder="Escoger hora"
              v-model="formData.start_time"
              local="en"
            />
              
          </b-form-group>
          <b-form-group
              label="Seleccione la hora de terminación de la jornada laboral del usuario:"
              label-for="timepicker-check-in"
              class="w-50"
            >
  
            <b-form-timepicker
              id="timepicker-check-in"
              placeholder="Escoger hora"
              v-model="formData.end_time"
              local="en"
            />
              
          </b-form-group>

          <b-form-group
            label="Horas trabajadas por el usuario"
            label-for="time"
            class="w-50"
          >
              
            <b-form-input
              id="time"
              v-model="formData.worked_hours"
              type="number"
          
              :state="validationTime"
              onKeyUp=" if (this.value.length > 5) {this.value = this.value.slice(0, 5)} if(this.value<0){this.value= this.value * -1}"
              placeholder="Horas trabajadas "
            />
            <b-form-invalid-feedback :state="validationTime">
                Este campo es obligatorio y debe ser mayor o igual a cero
            </b-form-invalid-feedback>
          </b-form-group>

          <b-form-group
              label="Retardo del usuario:"
              label-for="select-attendance-delayed"
              class="w-50"
            >
              <b-form-select name="select-attendance-delayed" v-model="formData.delayed" class="mb-3" id="select-attendance-delayed">
                <b-form-select-option :value="0" >-- No --</b-form-select-option>
                <b-form-select-option :value="1">-- Si --</b-form-select-option>
              </b-form-select>
          
                  
          </b-form-group>
 
        <b-button  variant="primary" @click="submit"  class="ml-1" :disabled="lockedSubmit">
            Guardar
        </b-button>
         <b-button  variant="outline-secondary" @click="cancel"  class="ml-1">
            Cancelar
        </b-button>
      </b-form>
    </b-modal>
  </div>
    
</template>

<script>
import BCardCode from '@core/components/b-card-code'
import {
  BButton, BModal, VBModal, BForm, BFormInput, BFormGroup, BCardText,BFormDatepicker, BFormInvalidFeedback, 
  BFormSelect,BFormSelectOption, BFormTimepicker
} from 'bootstrap-vue'
import Ripple from 'vue-ripple-directive'

export default {
  components: {
    BCardCode,
    BButton,
    BModal,
    BForm,
    BFormInput,
    BCardText,
    BFormGroup,
    BFormDatepicker,
    BFormInvalidFeedback, 
    BFormSelect,
    BFormSelectOption,
    BFormTimepicker
  },
  directives: {
    'b-modal': VBModal,
    Ripple,
  },
  data() {
    return {
        formData:{
            id:'',
            user_id:'',
            date:'',
            start_time:'',
            end_time:'',
            worked_hours:null,
            delayed:''
        },
        lockedSubmit:false
  

    }
  },
  methods:{
      submit(){

        this.$swal({          
          title: '¿Está seguro de actualizar el registro?',
          text: "!El registro de asistencia deñ usuario será actualizado!",
          icon: 'warning',
          showCancelButton: true,
          confirmButtonText: 'Si, guardar!',
          customClass: {
            confirmButton: 'btn btn-primary',
            cancelButton: 'btn btn-outline-danger ml-1',
          },
          buttonsStyling: false,

        }).then(result => {
          if (result.value) {

            this.$http.post("user/attendance/edit", this.formData).then((res) => {
          
            if (res.data.message === "success") {
              this.$swal({
                        icon: 'success',
                        title: 'Guardado!',
                        text: 'El registro ha sido actualizado correctamente.',
                        customClass: {
                          confirmButton: 'btn btn-success',
                        },
              })
              this.$bvModal.hide('modal-editAttendance')
              this.getAttendanceData()
              this.$emit('success', true)
                  }
            }).catch((err) => {
                console.log(err);
            });
            
            } else {
            this.$swal({
              title: 'Cancelado',
              text: 'El registro no ha sido guardado',
              icon: 'error',
              customClass: {
                confirmButton: 'btn btn-success',
              },
            })
          }
        })
        
      },
      cancel(){
        this.$bvModal.hide('modal-editAttendance')
      },
      getAttendanceData(){
        this.$http.get('user/attendance/show',{params:{attendance:this.$route.params.attendance}}).then(res=>{
          this.formData.id = res.data.attendance.id
          this.formData.date = res.data.attendance.date
          this.formData.start_time = res.data.attendance.start_time
          this.formData.end_time = res.data.attendance.end_time
          this.formData.worked_hours = res.data.attendance.worked_hours
          this.formData.delayed = res.data.attendance.delayed

        }).catch(err=>{
          console.log(err)
        })
      },
  },
  computed: {
      validationTime() {
        if(this.formData.worked_hours != ''){
          if(this.formData.worked_hours >= 0 || this.formData.worked_hours==0){
            this.lockedSubmit = false
            return true
          }
        }else if(this.formData.worked_hours === ''){
          this.lockedSubmit = true
          return false
          
        }else if(this.formData.worked_hours < 0){
          this.lockedSubmit = true
          return false
        }
       
      },
    
      
     
    },
  mounted(){
    this.getAttendanceData()
  }
}
</script>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
</style>
